Index: trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F	(revision 2150)
+++ trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F	(revision 2151)
@@ -4707,12 +4707,12 @@
             
             if (o1d_eq(i).eq.'Y') then
-               log1 = dlog10(o1dxpares(1))
-               log2 = dlog10(o1dxpares(2))
-               log3 = dlog10(o1dxpares(3))
+               log1 = log10(o1dxpares(1))
+               log2 = log10(o1dxpares(2))
+               log3 = log10(o1dxpares(3))
                avg_pares = avg(log1,log2,log3)
                dif_pares = dif(log1,log2,log3,avg_pares)
-               log1 = dlog10(o1dximpar(1))
-               log2 = dlog10(o1dximpar(2))
-               log3 = dlog10(o1dximpar(3))
+               log1 = log10(o1dximpar(1))
+               log2 = log10(o1dximpar(2))
+               log3 = log10(o1dximpar(3))
                avg_impar = avg(log1,log2,log3)
                dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4726,12 +4726,12 @@
             
             if (oh_eq(i).eq.'Y') then
-               log1 = dlog10(ohxpares(1))
-               log2 = dlog10(ohxpares(2))
-               log3 = dlog10(ohxpares(3))
+               log1 = log10(ohxpares(1))
+               log2 = log10(ohxpares(2))
+               log3 = log10(ohxpares(3))
                avg_pares = avg(log1,log2,log3)
                dif_pares = dif(log1,log2,log3,avg_pares)
-               log1 = dlog10(ohximpar(1))
-               log2 = dlog10(ohximpar(2))
-               log3 = dlog10(ohximpar(3))
+               log1 = log10(ohximpar(1))
+               log2 = log10(ohximpar(2))
+               log3 = log10(ohximpar(3))
                avg_impar = avg(log1,log2,log3)
                dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4746,12 +4746,12 @@
             
             if (ho2_eq(i).eq.'Y') then
-               log1 = dlog10(ho2xpares(1))
-               log2 = dlog10(ho2xpares(2))
-               log3 = dlog10(ho2xpares(3))
+               log1 = log10(ho2xpares(1))
+               log2 = log10(ho2xpares(2))
+               log3 = log10(ho2xpares(3))
                avg_pares = avg(log1,log2,log3)
                dif_pares = dif(log1,log2,log3,avg_pares)
-               log1 = dlog10(ho2ximpar(1))
-               log2 = dlog10(ho2ximpar(2))
-               log3 = dlog10(ho2ximpar(3))
+               log1 = log10(ho2ximpar(1))
+               log2 = log10(ho2ximpar(2))
+               log3 = log10(ho2ximpar(3))
                avg_impar = avg(log1,log2,log3)
                dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4765,12 +4765,12 @@
             
             if (h_eq(i).eq.'Y') then
-               log1 = dlog10(hxpares(1))
-               log2 = dlog10(hxpares(2))
-               log3 = dlog10(hxpares(3))
+               log1 = log10(hxpares(1))
+               log2 = log10(hxpares(2))
+               log3 = log10(hxpares(3))
                avg_pares = avg(log1,log2,log3)
                dif_pares = dif(log1,log2,log3,avg_pares)
-               log1 = dlog10(hximpar(1))
-               log2 = dlog10(hximpar(2))
-               log3 = dlog10(hximpar(3))
+               log1 = log10(hximpar(1))
+               log2 = log10(hximpar(2))
+               log3 = log10(hximpar(3))
                avg_impar = avg(log1,log2,log3)
                dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4786,12 +4786,12 @@
             if(chemthermod.ge.2) then
                if (n2d_eq(i).eq.'Y') then
-                  log1 = dlog10(n2dxpares(1))
-                  log2 = dlog10(n2dxpares(2))
-                  log3 = dlog10(n2dxpares(3))
+                  log1 = log10(n2dxpares(1))
+                  log2 = log10(n2dxpares(2))
+                  log3 = log10(n2dxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(n2dximpar(1))
-                  log2 = dlog10(n2dximpar(2))
-                  log3 = dlog10(n2dximpar(3))
+                  log1 = log10(n2dximpar(1))
+                  log2 = log10(n2dximpar(2))
+                  log3 = log10(n2dximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4805,12 +4805,12 @@
             
                if (no2_eq(i).eq.'Y') then
-                  log1 = dlog10(no2xpares(1))
-                  log2 = dlog10(no2xpares(2))
-                  log3 = dlog10(no2xpares(3))
+                  log1 = log10(no2xpares(1))
+                  log2 = log10(no2xpares(2))
+                  log3 = log10(no2xpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(no2ximpar(1))
-                  log2 = dlog10(no2ximpar(2))
-                  log3 = dlog10(no2ximpar(3))
+                  log1 = log10(no2ximpar(1))
+                  log2 = log10(no2ximpar(2))
+                  log3 = log10(no2ximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4829,12 +4829,12 @@
             if(chemthermod.eq.3) then
                if (cplus_eq(i).eq.'Y') then
-                  log1 = dlog10(cplusxpares(1))
-                  log2 = dlog10(cplusxpares(2))
-                  log3 = dlog10(cplusxpares(3))
+                  log1 = log10(cplusxpares(1))
+                  log2 = log10(cplusxpares(2))
+                  log3 = log10(cplusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(cplusximpar(1))
-                  log2 = dlog10(cplusximpar(2))
-                  log3 = dlog10(cplusximpar(3))
+                  log1 = log10(cplusximpar(1))
+                  log2 = log10(cplusximpar(2))
+                  log3 = log10(cplusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4848,12 +4848,12 @@
                
                if (coplus_eq(i).eq.'Y') then
-                  log1 = dlog10(coplusxpares(1))
-                  log2 = dlog10(coplusxpares(2))
-                  log3 = dlog10(coplusxpares(3))
+                  log1 = log10(coplusxpares(1))
+                  log2 = log10(coplusxpares(2))
+                  log3 = log10(coplusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(coplusximpar(1))
-                  log2 = dlog10(coplusximpar(2))
-                  log3 = dlog10(coplusximpar(3))
+                  log1 = log10(coplusximpar(1))
+                  log2 = log10(coplusximpar(2))
+                  log3 = log10(coplusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4867,12 +4867,12 @@
                
                if (oplus_eq(i).eq.'Y') then
-                  log1 = dlog10(oplusxpares(1))
-                  log2 = dlog10(oplusxpares(2))
-                  log3 = dlog10(oplusxpares(3))
+                  log1 = log10(oplusxpares(1))
+                  log2 = log10(oplusxpares(2))
+                  log3 = log10(oplusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(oplusximpar(1))
-                  log2 = dlog10(oplusximpar(2))
-                  log3 = dlog10(oplusximpar(3))
+                  log1 = log10(oplusximpar(1))
+                  log2 = log10(oplusximpar(2))
+                  log3 = log10(oplusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4886,12 +4886,12 @@
                
                if (n2plus_eq(i).eq.'Y') then
-                  log1 = dlog10(n2plusxpares(1))
-                  log2 = dlog10(n2plusxpares(2))
-                  log3 = dlog10(n2plusxpares(3))
+                  log1 = log10(n2plusxpares(1))
+                  log2 = log10(n2plusxpares(2))
+                  log3 = log10(n2plusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(n2plusximpar(1))
-                  log2 = dlog10(n2plusximpar(2))
-                  log3 = dlog10(n2plusximpar(3))
+                  log1 = log10(n2plusximpar(1))
+                  log2 = log10(n2plusximpar(2))
+                  log3 = log10(n2plusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4905,12 +4905,12 @@
                
                if (hplus_eq(i).eq.'Y') then
-                  log1 = dlog10(hplusxpares(1))
-                  log2 = dlog10(hplusxpares(2))
-                  log3 = dlog10(hplusxpares(3))
+                  log1 = log10(hplusxpares(1))
+                  log2 = log10(hplusxpares(2))
+                  log3 = log10(hplusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(hplusximpar(1))
-                  log2 = dlog10(hplusximpar(2))
-                  log3 = dlog10(hplusximpar(3))
+                  log1 = log10(hplusximpar(1))
+                  log2 = log10(hplusximpar(2))
+                  log3 = log10(hplusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4924,12 +4924,12 @@
                
                if (co2plus_eq(i).eq.'Y') then
-                  log1 = dlog10(co2plusxpares(1))
-                  log2 = dlog10(co2plusxpares(2))
-                  log3 = dlog10(co2plusxpares(3))
+                  log1 = log10(co2plusxpares(1))
+                  log2 = log10(co2plusxpares(2))
+                  log3 = log10(co2plusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(co2plusximpar(1))
-                  log2 = dlog10(co2plusximpar(2))
-                  log3 = dlog10(co2plusximpar(3))
+                  log1 = log10(co2plusximpar(1))
+                  log2 = log10(co2plusximpar(2))
+                  log3 = log10(co2plusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4943,12 +4943,12 @@
                
                if (o2plus_eq(i).eq.'Y') then
-                  log1 = dlog10(o2plusxpares(1))
-                  log2 = dlog10(o2plusxpares(2))
-                  log3 = dlog10(o2plusxpares(3))
+                  log1 = log10(o2plusxpares(1))
+                  log2 = log10(o2plusxpares(2))
+                  log3 = log10(o2plusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(o2plusximpar(1))
-                  log2 = dlog10(o2plusximpar(2))
-                  log3 = dlog10(o2plusximpar(3))
+                  log1 = log10(o2plusximpar(1))
+                  log2 = log10(o2plusximpar(2))
+                  log3 = log10(o2plusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4962,12 +4962,12 @@
                
                if (noplus_eq(i).eq.'Y') then
-                  log1 = dlog10(noplusxpares(1))
-                  log2 = dlog10(noplusxpares(2))
-                  log3 = dlog10(noplusxpares(3))
+                  log1 = log10(noplusxpares(1))
+                  log2 = log10(noplusxpares(2))
+                  log3 = log10(noplusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(noplusximpar(1))
-                  log2 = dlog10(noplusximpar(2))
-                  log3 = dlog10(noplusximpar(3))
+                  log1 = log10(noplusximpar(1))
+                  log2 = log10(noplusximpar(2))
+                  log3 = log10(noplusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -4981,12 +4981,12 @@
                
                if (nplus_eq(i).eq.'Y') then
-                  log1 = dlog10(nplusxpares(1))
-                  log2 = dlog10(nplusxpares(2))
-                  log3 = dlog10(nplusxpares(3))
+                  log1 = log10(nplusxpares(1))
+                  log2 = log10(nplusxpares(2))
+                  log3 = log10(nplusxpares(3))
                   avg_pares = avg(log1,log2,log3)
                   dif_pares = dif(log1,log2,log3,avg_pares)
-                  log1 = dlog10(nplusximpar(1))
-                  log2 = dlog10(nplusximpar(2))
-                  log3 = dlog10(nplusximpar(3))
+                  log1 = log10(nplusximpar(1))
+                  log2 = log10(nplusximpar(2))
+                  log3 = log10(nplusximpar(3))
                   avg_impar = avg(log1,log2,log3)
                   dif_impar = dif(log1,log2,log3,avg_impar)
@@ -5000,12 +5000,12 @@
 
                if (hco2plus_eq(i).eq.'Y') then
-                 log1 = dlog10(hco2plusxpares(1))
-                 log2 = dlog10(hco2plusxpares(2))
-                 log3 = dlog10(hco2plusxpares(3))
+                 log1 = log10(hco2plusxpares(1))
+                 log2 = log10(hco2plusxpares(2))
+                 log3 = log10(hco2plusxpares(3))
                  avg_pares = avg(log1,log2,log3)
                  dif_pares = dif(log1,log2,log3,avg_pares)
-                 log1 = dlog10(hco2plusximpar(1))
-                 log2 = dlog10(hco2plusximpar(2))
-                 log3 = dlog10(hco2plusximpar(3))
+                 log1 = log10(hco2plusximpar(1))
+                 log2 = log10(hco2plusximpar(2))
+                 log3 = log10(hco2plusximpar(3))
                  avg_impar = avg(log1,log2,log3)
                  dif_impar = dif(log1,log2,log3,avg_impar)