Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/abort_gcm.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/abort_gcm.F	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/abort_gcm.F	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/abort_gcm.F
+link ../../../../LMDZ.COMMON/libf/dyn3d/abort_gcm.F
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/comconst_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/comconst_mod.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/comconst_mod.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/comconst_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/comconst_mod.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/comgeom.h
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/comgeom.h	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/comgeom.h	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/comgeom.h
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/comgeom.h
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/comvert_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/comvert_mod.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/comvert_mod.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/comvert_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/comvert_mod.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/control_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/control_mod.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/control_mod.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/control_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/control_mod.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/disvert.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/disvert.F	(revision 2079)
+++ 	(revision )
@@ -1,1 +1,0 @@
-link ../../dyn3d/disvert.F
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/disvert_noterre.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/disvert_noterre.F	(revision 2167)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/disvert_noterre.F	(revision 2167)
@@ -0,0 +1,1 @@
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/disvert_noterre.F
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/ener_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/ener_mod.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/ener_mod.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/ener_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/ener_mod.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/infotrac.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/infotrac.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/infotrac.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/infotrac.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/infotrac.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/logic_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/logic_mod.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/logic_mod.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/logic_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d/logic_mod.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/mod_const_mpi.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/mod_const_mpi.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/mod_const_mpi.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/mod_const_mpi.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d/mod_const_mpi.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/paramet.h
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/paramet.h	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/paramet.h	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/paramet.h
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/paramet.h
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/serre_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/serre_mod.F90	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/serre_mod.F90	(revision 2167)
@@ -1,1 +1,1 @@
-link ../../dyn3d/serre_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/serre_mod.F90
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F	(revision 2079)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F	(revision 2167)
@@ -625,5 +625,5 @@
       write(*,*) " hybrid = ", hybrid
 
-      CALL  disvert
+      CALL  disvert_noterre
       ! now that disvert has been called, initialize module vertical_layers_mod
       call init_vertical_layers(nlayer,preff,scaleheight,