Index: trunk/LMDZ.VENUS/libf/phyvenus/cloudvenus/new_cloud_sedim.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/cloudvenus/new_cloud_sedim.F	(revision 2199)
+++ trunk/LMDZ.VENUS/libf/phyvenus/cloudvenus/new_cloud_sedim.F	(revision 2200)
@@ -1,6 +1,6 @@
-      SUBROUTINE new_cloud_sedim(n_lon,n_lev,ptimestep,
-     &                pmidlay,pbndlay, 
-     &                pt,
-     &                pq, pdqsed,pdqs_sed,nq,F_sed)
+      subroutine new_cloud_sedim(n_lon, n_lev, ptimestep,
+     $                           pmidlay, pbndlay, pt, pq,
+     $                           d_tr_chem, pdqsed, pdqs_sed,
+     $                           nq, F_sed)
 
       USE ioipsl
@@ -8,8 +8,4 @@
       USE chemparam_mod
       IMPLICIT NONE
-
-c=======================================================================
-c      
-c=======================================================================
 
 c-----------------------------------------------------------------------
@@ -21,5 +17,4 @@
 c#include "tracer.h"
 c#include "callkeys.h"
-	
 c
 c   arguments:
@@ -36,6 +31,6 @@
       integer nq                    ! number of tracers
       real pq(n_lon,n_lev,nq)       ! tracers (kg/kg)
-c      real pdqfi(n_lon,n_lev,nq)   ! tendency before sedimentation (kg/kg.s-1)
       real pdqsed(n_lon,n_lev,2)    ! tendency due to sedimentation (kg/kg)
+      real d_tr_chem(n_lon,n_lev,nq)! tendency due to chemistry and clouds (kg/kg)
       real pdqs_sed(n_lon)          ! surface density (Flux if /ptimestep) at surface due to sedimentation (kg.m-2)
       
@@ -73,6 +68,5 @@
       REAL, PARAMETER :: rho_core = 2500.0
 
-      REAL, DIMENSION(n_lon,n_lev+1) ::
-     + wgt_SA                         ! Fraction of H2SO4 in droplet local
+      REAL, DIMENSION(n_lon,n_lev+1) :: wgt_SA   ! Fraction of H2SO4 in droplet local
 
 c     Stokes speed and sedimentation flux variable
@@ -87,8 +81,5 @@
      + F_sed                          ! Flux de sedimentation (kg.m-2.s-1 puis en output kg.m-2)
       
-      
       REAL :: R_mode0                 ! Rayon mode 0 (m), rayon le plus frequent
-
-
 
 !      PRINT*,'RHO_DROPLET new_cloud_sedim.F'
@@ -100,14 +91,10 @@
 c    -----------------
     
-c     Updating the droplet mass mixing ratio with the partition H2O/H2SO4
-c     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-      do l=1,n_lev
-         do ig=1,n_lon
-         zqi_wv(ig,l) = pq(ig,l,i_h2oliq)
-         zqi_sa(ig,l) = pq(ig,l,i_h2so4liq)
-         wgt_SA(ig,l) = WH2SO4(ig,l)
-         enddo
-      enddo 
+!     Updating the droplet mass mixing ratio with the partition H2O/H2SO4
+
+      zqi_wv(:,:) = pq(:,:,i_h2oliq) + d_tr_chem(:,:,i_h2oliq)*ptimestep
+      zqi_sa(:,:) = pq(:,:,i_h2so4liq) 
+     $            + d_tr_chem(:,:,i_h2so4liq)*ptimestep
+      wgt_SA(:,:) = wh2so4(:,:)
 
 c     Init F_sed
Index: trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F	(revision 2199)
+++ trunk/LMDZ.VENUS/libf/phyvenus/physiq_mod.F	(revision 2200)
@@ -1013,4 +1013,5 @@
      $                              t_seri,
      $                              tr_seri,
+     $                              d_tr_chem,
      $                              d_tr_sed(:,:,1:2),
      $                              d_tr_ssed,
Index: trunk/LMDZ.VENUS/libf/phyvenus/phytrac_chimie.F
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/phytrac_chimie.F	(revision 2199)
+++ trunk/LMDZ.VENUS/libf/phyvenus/phytrac_chimie.F	(revision 2200)
@@ -270,5 +270,6 @@
 
       do iq = 1,nqmax - nmicro
-         ztrac(:,:,iq) = ztrac(:,:,iq)*m_tr(iq)/mmean(:,:)
+         ztrac(:,:,iq) = max(ztrac(:,:,iq)*m_tr(iq)/mmean(:,:), 
+     $                       1.e-30)
          d_tr_chem(:,:,iq) = (ztrac(:,:,iq) - trac(:,:,iq))/pdtphys
       end do
@@ -277,8 +278,10 @@
 
       if (ok_cloud .and. cl_scheme == 1) then
-         ztrac(:,:,i_h2so4liq) = ztrac(:,:,i_h2so4liq)*m_tr(i_h2so4liq)
-     $                           /mmean(:,:)
-         ztrac(:,:,i_h2oliq) = ztrac(:,:,i_h2oliq)*m_tr(i_h2oliq)
-     $                         /mmean(:,:)
+         ztrac(:,:,i_h2so4liq) = max(ztrac(:,:,i_h2so4liq)
+     $                               *m_tr(i_h2so4liq)/mmean(:,:),
+     $                               1.e-30)
+         ztrac(:,:,i_h2oliq)   = max(ztrac(:,:,i_h2oliq)
+     $                               *m_tr(i_h2oliq)/mmean(:,:),
+     $                               1.e-30)
          d_tr_chem(:,:,i_h2so4liq) = (ztrac(:,:,i_h2so4liq) 
      $                              - trac(:,:,i_h2so4liq))/pdtphys